--------------------------------------------------------------------------------
-- Company: <Name>
--
-- File: IGLOO_TOP.vhd
-- File history:
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- <Description here>
--
-- Targeted device: <Family::IGLOO> <Die::AGL250V2> <Package::100 VQFP>
-- Author: <Name>
--
--------------------------------------------------------------------------------
library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity IGLOO_TOP is
port (
	 		-- Connection to the Zarlink 
		SPI_ZL_CS 						: out STD_LOGIC;
		SPI_SDI 						: out STD_LOGIC;
		SPI_SDO 						: in  STD_LOGIC;
		SPI_CLK 						: out STD_LOGIC;

		-- For the data stream
		RHA_ADC_out 					: in  STD_LOGIC_VECTOR(7 downto 0);
		-- Where a RHA data frame starts 
		RHA_sync 						: in  STD_LOGIC_VECTOR(7 downto 0);
		-- RHA ADC clock
		RHA_ADC_clk						: out STD_LOGIC_VECTOR(7 downto 0);

		-- RHA Reset
		RHA_Reset						: out STD_LOGIC_VECTOR(7 downto 0);
		
--		DEBUG_STRING_ORGANIZER			: out std_logic_vector (3 downto 0);

		Reset 							: in  STD_LOGIC;				
		Clk 							: in  STD_LOGIC
);
end IGLOO_TOP;
architecture IGLOO_TOP_ARCH of IGLOO_TOP is

begin

	MYImplant : entity work.IMPLANT_TOP
    Port MAP ( 
	 		-- Connection to the Zarlink 
		SPI_ZL_CS => SPI_ZL_CS,
		SPI_SDI => SPI_SDI,
		SPI_SDO => SPI_SDO,
		SPI_CLK => SPI_CLK,

		-- For the data stream
		RHA_ADC_out => RHA_ADC_out,
		-- Where a RHA data frame starts 
		RHA_sync => RHA_sync,
		-- RHA ADC clock
		RHA_ADC_clk	 => RHA_ADC_clk,

		-- RHA Reset
		RHA_Reset => RHA_Reset,
	
		-- Debugging the Zarlink 
		DEBUG_ZARLINK_DATA => open,
		DEBUG_ZARLINK_VALID	=> open,

		-- Error flags 
		ERROR_RHA_ASYNC_FIRST_OUT => open,
		ERROR_RHA_ASYNC_VALID_OUT => open,
		ERROR_PARITY_OUT => open,
		ERROR_PATTERN_OUT => open,
		ERROR_ADDRESS_OUT => open,
		ERROR_BUFFEROVERFLOW_OUT => open,
		ERROR_ALL_OUT => open,

		DEBUG_STRING_ORGANIZER => open,

		-- The usual ports 
		Reset => NOT Reset,
		Clk_FAST => Clk

	 );

   -- architecture body
end IGLOO_TOP_ARCH;
