----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:05:50 07/30/2014 
-- Design Name: 
-- Module Name:    RHA_TESTMODULE - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;


entity RHA_TESTMODULE is
    Port (
		-- For the data stream
		RHA_ADC_out 				: out  STD_LOGIC_VECTOR(7 downto 0);
		-- Where a RHA data frame starts 
		RHA_ADC_sync 				: out  STD_LOGIC_VECTOR(7 downto 0);
		RHA_sync 					: out  STD_LOGIC_VECTOR(7 downto 0);
		-- RHA ADC clock
		RHA_ADC_clk					: in STD_LOGIC;
		
		-- RHA Reset
		RHA_Reset					: in STD_LOGIC
		);
end RHA_TESTMODULE;

architecture Behavioral of RHA_TESTMODULE is

begin

	RHA_TEST_MOD_0: entity work.RHA_TEST_MODULATOR 
    Port MAP (
				CHANNEL_ID 		=>  "000",
				ADC_OUT			=> RHA_ADC_out(0),
				ADC_SYNC 		=> RHA_ADC_sync(0),
				SYNC			=> RHA_sync(0),
				Clk 			=> RHA_ADC_clk,
				Reset 			=> RHA_Reset
			);

	RHA_TEST_MOD_1: entity work.RHA_TEST_MODULATOR 
    Port MAP (
				CHANNEL_ID 		=>  "001",
				ADC_OUT			=> RHA_ADC_out(1),
				ADC_SYNC 		=> RHA_ADC_sync(1),
				SYNC			=> RHA_sync(1),
				Clk 			=> RHA_ADC_clk,
				Reset 			=> RHA_Reset
			);
			
	RHA_TEST_MOD_2: entity work.RHA_TEST_MODULATOR 
    Port MAP (	
				CHANNEL_ID		=>  "010",
				ADC_OUT			=> RHA_ADC_out(2),
				ADC_SYNC 		=> RHA_ADC_sync(2),
				SYNC			=> RHA_sync(2),
				Clk 			=> RHA_ADC_clk,
				Reset 			=> RHA_Reset
			);

	RHA_TEST_MOD_3: entity work.RHA_TEST_MODULATOR 
    Port MAP (
				CHANNEL_ID		=>  "011",
				ADC_OUT			=> RHA_ADC_out(3),
				ADC_SYNC 		=> RHA_ADC_sync(3),
				SYNC			=> RHA_sync(3),
				Clk 			=> RHA_ADC_clk,
				Reset 			=> RHA_Reset
			);

	RHA_TEST_MOD_4: entity work.RHA_TEST_MODULATOR 
    Port MAP (
				CHANNEL_ID 		=>  "100",
				ADC_OUT			=> RHA_ADC_out(4),
				ADC_SYNC 		=> RHA_ADC_sync(4),
				SYNC			=> RHA_sync(4),
				Clk 			=> RHA_ADC_clk,
				Reset 			=> RHA_Reset
			);

	RHA_TEST_MOD_5: entity work.RHA_TEST_MODULATOR 
    Port MAP (
				CHANNEL_ID 		=>  "101",
				ADC_OUT			=> RHA_ADC_out(5),
				ADC_SYNC 		=> RHA_ADC_sync(5),
				SYNC			=> RHA_sync(5),
				Clk 			=> RHA_ADC_clk,
				Reset 			=> RHA_Reset
			);

	RHA_TEST_MOD_6: entity work.RHA_TEST_MODULATOR 
    Port MAP (
				CHANNEL_ID 		=>  "110",
				ADC_OUT			=> RHA_ADC_out(6),
				ADC_SYNC 		=> RHA_ADC_sync(6),
				SYNC			=> RHA_sync(6),
				Clk 			=> RHA_ADC_clk,
				Reset 			=> RHA_Reset
			);

	RHA_TEST_MOD_7: entity work.RHA_TEST_MODULATOR 
    Port MAP (
				CHANNEL_ID 		=>  "111",
				ADC_OUT			=> RHA_ADC_out(7),
				ADC_SYNC 		=> RHA_ADC_sync(7),
				SYNC			=> RHA_sync(7),
				Clk 			=> RHA_ADC_clk,
				Reset 			=> RHA_Reset
			);

end Behavioral;

