----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:37:35 07/30/2014 
-- Design Name: 
-- Module Name:    RHA_TEST_MODULATOR - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity RHA_TEST_MODULATOR is
    Port (
				CHANNEL_ID 		: in std_logic_vector(2 downto 0);
				
				ADC_OUT			: out STD_LOGIC;
				ADC_SYNC 		: out STD_LOGIC;
				SYNC			: out STD_LOGIC;
				Clk 			: in  STD_LOGIC;
				Reset 			: in  STD_LOGIC
			);
end RHA_TEST_MODULATOR;

architecture Behavioral of RHA_TEST_MODULATOR is

	type STATE_Type is (
		SM_RESET,
		SM_Bit00,
		SM_Bit01,
		SM_Bit02,
		SM_Bit03,
		SM_Bit04,
		SM_Bit05,
		SM_Bit06,
		SM_Bit07,
		SM_Bit08,
		SM_Bit09,
		SM_Bit10,
		SM_Bit11,
		SM_Bit12,
		SM_Bit13,
		SM_Bit14,
		SM_Bit15,
		SM_Bit16,
		SM_Bit17,
		SM_Bit18,
		SM_Bit19,
		SM_Bit20,
		SM_Bit21,
		SM_Bit22,
		SM_Bit23,
		SM_Bit24,
		SM_Bit00_B,
		SM_Bit01_B,
		SM_Bit02_B,
		SM_Bit03_B,
		SM_Bit04_B,
		SM_Bit05_B,
		SM_Bit06_B,
		SM_Bit07_B,
		SM_Bit08_B,
		SM_Bit09_B,
		SM_Bit10_B,
		SM_Bit11_B,
		SM_Bit12_B,
		SM_Bit13_B,
		SM_Bit14_B,
		SM_Bit15_B,
		SM_Bit16_B,
		SM_Bit17_B,
		SM_Bit18_B,
		SM_Bit19_B,
		SM_Bit20_B,
		SM_Bit21_B,
		SM_Bit22_B,
		SM_Bit23_B,
		SM_Bit24_B		
	);	
	signal SPIMACHINE_STATE : STATE_TYPE;		
	signal TESTVALUE_INTERNAL	: STD_LOGIC_VECTOR(24 downto 0) := (others => '0');
	signal TESTVALUE	: STD_LOGIC_VECTOR(24 downto 0) := (others => '0');
	signal LastChannel_Internal : std_logic := '0';
	signal NextValue_Internal : std_logic := '0';
 	signal ADC_OUT_INTERNAL : std_logic := '0';
	signal ADC_SYNC_INTERNAL  : std_logic := '0';
	signal SYNC_INTERNAL : std_logic := '0';


	signal DATAOUT_ADDRESS		: STD_LOGIC_VECTOR(4 downto 0) := (others => '0');
	signal DATAOUT_ADDRESS_R	: STD_LOGIC_VECTOR(4 downto 0) := (others => '0');
	signal Channel_Number		: STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
	signal Channel_Counter		: unsigned(3 downto 0) := (others => '0');

	signal Sample_Number			: STD_LOGIC_VECTOR(8 downto 0) := (others => '0');
	signal Sample_Counter		: unsigned(8 downto 0) := (others => '0');
	
	constant HEADER				: STD_LOGIC_VECTOR(2 downto 0) := "011";
	signal LAST_CHANNEL			: STD_LOGIC := '0';
	signal PARITY 				: STD_LOGIC := '0';
	signal TESTVALUE_GEN		: STD_LOGIC_VECTOR (24 downto 0) := (others => '0');
begin


	ADC_OUT <= ADC_OUT_INTERNAL;
	ADC_SYNC <= ADC_SYNC_INTERNAL;
	SYNC <= SYNC_INTERNAL;

	ADC_OUT_INTERNAL_PROCESS : process (Clk,Reset)
	begin
		if Reset = '1' then
			ADC_OUT_INTERNAL <= '0';
			NextValue_Internal <= '0';
			TESTVALUE_INTERNAL <= (others => '0');
			LastChannel_Internal <= '0';
			ADC_SYNC_INTERNAL <= '0';
			SYNC_INTERNAL <= '0';
			SPIMACHINE_STATE <= SM_RESET;

		elsif rising_edge(Clk) then
			NextValue_Internal <= '0';
			TESTVALUE_INTERNAL <= TESTVALUE_INTERNAL;
			LastChannel_Internal <= LastChannel_Internal;
			ADC_SYNC_INTERNAL <= '0';
			SYNC_INTERNAL <= '0';
			
			case SPIMACHINE_STATE is
				when SM_RESET =>
					SPIMACHINE_STATE <= SM_Bit00;
					ADC_OUT_INTERNAL <= '0';
				when SM_Bit00 =>
					SPIMACHINE_STATE <= SM_Bit00_B;
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 0);
				when SM_Bit00_B =>
					SPIMACHINE_STATE <= SM_Bit01;				
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 0);
					NextValue_Internal <= '1';
				when SM_Bit01 =>
					SPIMACHINE_STATE <= SM_Bit01_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 1);
				when SM_Bit01_B =>					
					SPIMACHINE_STATE <= SM_Bit02;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 1);
				when SM_Bit02 =>
					SPIMACHINE_STATE <= SM_Bit02_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 2);
				when SM_Bit02_B =>					
					SPIMACHINE_STATE <= SM_Bit03;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 2);
				when SM_Bit03 =>
					SPIMACHINE_STATE <= SM_Bit03_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 3);
				when SM_Bit03_B =>					
					SPIMACHINE_STATE <= SM_Bit04;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 3);
				when SM_Bit04 =>
					SPIMACHINE_STATE <= SM_Bit04_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 4);
				when SM_Bit04_B =>
					SPIMACHINE_STATE <= SM_Bit05;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 4);
				when SM_Bit05 =>
					SPIMACHINE_STATE <= SM_Bit05_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 5);
				when SM_Bit05_B =>					
					SPIMACHINE_STATE <= SM_Bit06;				
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 5);
				when SM_Bit06 =>
					SPIMACHINE_STATE <= SM_Bit06_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 6);
				when SM_Bit06_B =>					
					SPIMACHINE_STATE <= SM_Bit07;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 6);
				when SM_Bit07 =>
					SPIMACHINE_STATE <= SM_Bit07_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 7);
				when SM_Bit07_B =>					
					SPIMACHINE_STATE <= SM_Bit08;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 7);
				when SM_Bit08 =>
					SPIMACHINE_STATE <= SM_Bit08_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 8);
				when SM_Bit08_B =>
					SPIMACHINE_STATE <= SM_Bit09;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 8);
				when SM_Bit09 =>
					SPIMACHINE_STATE <= SM_Bit09_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 9);
				when SM_Bit09_B =>						
					SPIMACHINE_STATE <= SM_Bit10;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL( 9);
				when SM_Bit10 =>
					SPIMACHINE_STATE <= SM_Bit10_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(10);
				when SM_Bit10_B =>					
					SPIMACHINE_STATE <= SM_Bit11;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(10);
				when SM_Bit11 =>
					SPIMACHINE_STATE <= SM_Bit11_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(11);
				when SM_Bit11_B =>					
					SPIMACHINE_STATE <= SM_Bit12;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(11);
				when SM_Bit12 =>
					SPIMACHINE_STATE <= SM_Bit12_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(12);
				when SM_Bit12_B =>					
					SPIMACHINE_STATE <= SM_Bit13;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(12);
				when SM_Bit13 =>
					SPIMACHINE_STATE <= SM_Bit13_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(13);
				when SM_Bit13_B =>
					SPIMACHINE_STATE <= SM_Bit14;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(13);
				when SM_Bit14 =>
					SPIMACHINE_STATE <= SM_Bit14_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(14);
				when SM_Bit14_B =>					
					SPIMACHINE_STATE <= SM_Bit15;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(14);
				when SM_Bit15 =>
					SPIMACHINE_STATE <= SM_Bit15_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(15);
				when SM_Bit15_B =>					
					SPIMACHINE_STATE <= SM_Bit16;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(15);
				when SM_Bit16 =>
					SPIMACHINE_STATE <= SM_Bit16_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(16);
				when SM_Bit16_B =>					
					SPIMACHINE_STATE <= SM_Bit17;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(16);
				when SM_Bit17 =>
					SPIMACHINE_STATE <= SM_Bit17_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(17);
				when SM_Bit17_B =>					
					SPIMACHINE_STATE <= SM_Bit18;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(17);
				when SM_Bit18 =>
					SPIMACHINE_STATE <= SM_Bit18_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(18);
				when SM_Bit18_B =>					
					SPIMACHINE_STATE <= SM_Bit19;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(18);
				when SM_Bit19 =>
					SPIMACHINE_STATE <= SM_Bit19_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(19);
				when SM_Bit19_B =>					
					SPIMACHINE_STATE <= SM_Bit20;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(19);
				when SM_Bit20 =>
					SPIMACHINE_STATE <= SM_Bit20_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(20);
				when SM_Bit20_B =>					
					SPIMACHINE_STATE <= SM_Bit21;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(20);
				when SM_Bit21 =>
					SPIMACHINE_STATE <= SM_Bit21_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(21);
				when SM_Bit21_B =>					
					SPIMACHINE_STATE <= SM_Bit22;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(21);
				when SM_Bit22 =>
					SPIMACHINE_STATE <= SM_Bit22_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(22);
				when SM_Bit22_B =>					
					SPIMACHINE_STATE <= SM_Bit23;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(22);
				when SM_Bit23 =>
					SPIMACHINE_STATE <= SM_Bit23_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(23);
				when SM_Bit23_B =>					
					SPIMACHINE_STATE <= SM_Bit24;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(23);
					ADC_SYNC_INTERNAL <= '1';
					if LastChannel_Internal = '1' then
						SYNC_INTERNAL <= '1';	
					else
						SYNC_INTERNAL <= '0';
					end if;					
				when SM_Bit24 =>
					SPIMACHINE_STATE <= SM_Bit24_B;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(24);
					ADC_SYNC_INTERNAL <= '1';
					if LastChannel_Internal = '1' then
						SYNC_INTERNAL <= '1';	
					else
						SYNC_INTERNAL <= '0';
					end if;					
				when SM_Bit24_B =>
					SPIMACHINE_STATE <= SM_Bit00;								
					ADC_OUT_INTERNAL <= TESTVALUE_INTERNAL(24);
					TESTVALUE_INTERNAL <= TESTVALUE;
					LastChannel_Internal <= LAST_CHANNEL;
				when others => 
					ADC_OUT_INTERNAL <= '0';
			end case;

		end if;
	end process ADC_OUT_INTERNAL_PROCESS;

---------------------------------------------------------------------

	Channel_Number <= std_logic_vector(Channel_Counter);
	Sample_Number <= std_logic_vector(Sample_Counter);

	DATAOUT_ADDRESS_R(4) <= DATAOUT_ADDRESS(0);
	DATAOUT_ADDRESS_R(3) <= DATAOUT_ADDRESS(1);
	DATAOUT_ADDRESS_R(2) <= DATAOUT_ADDRESS(2);
	DATAOUT_ADDRESS_R(1) <= DATAOUT_ADDRESS(3);
	DATAOUT_ADDRESS_R(0) <= DATAOUT_ADDRESS(4);

	
	TESTVALUE_GEN <= PARITY & CHANNEL_ID & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;


	PARITY <= NOT ( CHANNEL_ID(2) XOR CHANNEL_ID(1) XOR CHANNEL_ID(0) XOR Channel_Number(3) XOR Channel_Number(2) 
		XOR Channel_Number(1) XOR Channel_Number(0) XOR Sample_Number(8) XOR Sample_Number(7) XOR Sample_Number(6) 
		XOR Sample_Number(5) XOR Sample_Number(4) XOR Sample_Number(3) XOR Sample_Number(2) XOR Sample_Number(1) XOR Sample_Number(0));


	Counter_Process : process (Clk,Reset)
	begin
		if Reset = '1' then
			Channel_Counter <= (others => '0');			 
			Sample_Counter <= (others => '0');
			LAST_CHANNEL <= '0';
			TESTVALUE <= (others => '0');
			
		elsif rising_edge(Clk) then
			TESTVALUE <= TESTVALUE_GEN;

			LAST_CHANNEL <= LAST_CHANNEL;
			
			if (NextValue_INTERNAL = '1') AND (Channel_Counter = to_unsigned(15,4)) then
				Channel_Counter <= (others => '0');
				Sample_Counter <= Sample_Counter + 1;
				LAST_CHANNEL <= '0';
			elsif (NextValue_INTERNAL = '1') AND (Channel_Counter = to_unsigned(14,4)) then
				Channel_Counter <= Channel_Counter + 1;
				Sample_Counter <= Sample_Counter;
				LAST_CHANNEL <= '1';
			elsif NextValue_INTERNAL = '1' then 
				Channel_Counter <= Channel_Counter + 1;
				Sample_Counter <= Sample_Counter;
				LAST_CHANNEL <= '0';
			else
				Channel_Counter <= Channel_Counter;
				Sample_Counter <= Sample_Counter;
			end if;
		end if;
	end process Counter_Process;

	PatternAddress : process (Channel_Number)
	begin

		case Channel_Number is

			-- 0
			when "0000" => 
				DATAOUT_ADDRESS <= "01000";
			-- 1
			when "0001" => 
				DATAOUT_ADDRESS <= "01001";
			-- 2
			when "0010" => 
				DATAOUT_ADDRESS <= "01010";
			-- 3
			when "0011" => 
				DATAOUT_ADDRESS <= "01011";
			-- 4
			when "0100" => 
				DATAOUT_ADDRESS <= "01100";
			-- 5
			when "0101" => 
				DATAOUT_ADDRESS <= "01101";
			-- 6
			when "0110" => 
				DATAOUT_ADDRESS <= "01110";
			-- 7
			when "0111" => 
				DATAOUT_ADDRESS <= "01111";
			-- 8
			when "1000" => 
				DATAOUT_ADDRESS <= "10000";
			-- 9
			when "1001" => 
				DATAOUT_ADDRESS <= "10001";
			-- 10
			when "1010" => 
				DATAOUT_ADDRESS <= "10010";
			-- 11
			when "1011" => 
				DATAOUT_ADDRESS <= "10011";
			-- 12
			when "1100" => 
				DATAOUT_ADDRESS <= "10100";
			-- 13
			when "1101" => 
				DATAOUT_ADDRESS <= "10101";
			-- 14
			when "1110" =>
				DATAOUT_ADDRESS <= "10110";
			-- 15
			when "1111" => 
				DATAOUT_ADDRESS <= "10111";
			when others => 
				DATAOUT_ADDRESS <= "00000";
		end case;

	end process PatternAddress;

end Behavioral;

